#Copyright 2009 Daniel Monedero Tortola faltantornillos at gmail.com

#This file is part of Bright Player 0.3.

#    Bright Player 0.3 is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    Bright Player 0.3 is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

import gtk
import os
import commands
from signal import signal, SIGTERM
from sys import exit
import atexit

#Settings:
musicPathOn='/media/mmcblk0p2/home/root/MusicOn/*'
musicPathOff='/media/mmcblk0p2/home/root/MusicOff/*'
defaultBrightness='204'
defaultVolume='118'

#Code:
playing = 0
muted=0
unmutedValue=0.0
one=-1
two=-1
three=-1
four=-1

def cleanupFunc():
	global playing
	global defaultVolume
	unlock()
	os.system('xset s on');
	if playing == 1:
		playing=0
		os.system('killall mplayer')
		os.system('amixer cset iface=MIXER,name=\'Amp Spk Switch\' off > /dev/null')
		os.system('kill `ps -e -o pid,command | grep [d]etector.py | awk {\'print $1\'}`')
		os.system('amixer cset iface=MIXER,name=\'Headphone Playback Volume\' '+defaultVolume+' '+defaultVolume+' > /dev/null')

def exitFunc(target):
	exit(0)

def volume(widget): 
	value = widget.get_value()
	os.system ('amixer sset \'Headphone\' '+str(int(value))+' > /dev/null &')

def mute(self): 
	global muted
	global unmutedValue
	global volumeScale
	if muted==0 :
		os.system ('amixer sset \'Headphone\' 0 > /dev/null &')
		self.set_image(unmuteImage)
		unmutedValue=volumeScale.get_value()
		volumeScale.set_value(0)
		muted=1
	else :
		os.system ('amixer sset \'Headphone\' '+str(int(unmutedValue))+' > /dev/null &')
		self.set_image(muteImage)
		volumeScale.set_value(int(unmutedValue))
		muted=0

def lock(target):
	os.system('echo 1 > /sys/class/backlight/gta02-bl/bl_power')
	w.fullscreen()
	hBoxOn.hide()
	hBoxOff.hide()
	hBoxVol.hide()
	hBoxExitLock.hide()
	lockUpBox.show()
	lockDownBox.show()

def unlock():
	global defaultBrightness
	os.system('echo 0 > /sys/class/backlight/gta02-bl/bl_power')
	os.system('echo '+defaultBrightness+' > /sys/class/backlight/gta02-bl/brightness')
	w.unfullscreen()
	hBoxOn.hide()
	hBoxOff.hide()
	lockUpBox.hide()
	lockDownBox.hide()
	hBoxExitLock.show()
	hBoxVol.show()

def onFocusOutFunc(sender, event):
	global focusOutId
	w.disconnect(focusOutId)
	exitFunc(0)


def playFunc(target, parameter):
	global playing
	global musicPathOn
	global musicPathOff
	global defaultVolume
	global focusOutId
	os.system('echo 1 > /sys/class/backlight/gta02-bl/bl_power');
	os.system('xset s off');
	if playing == 0:
		os.system('fsoraw --resources CPU brightPlayer');
		playing = 1
		lock(0)
		#set alsa
		if (parameter == 'handOn') or (parameter == 'handOff'):
			os.system('amixer cset iface=MIXER,name=\'Amp Spk Switch\' on > /dev/null &')
		else:
			os.system('amixer cset iface=MIXER,name=\'Amp Spk Switch\' off > /dev/null &')
		#play right path
		if (parameter == 'handOn') or (parameter == 'headOn'):
			os.system('mplayer -really-quiet -noconsolecontrols -nojoystick -nolirc -nomouseinput -shuffle '+musicPathOn+' > /dev/null &')
		else:
			os.system('mplayer -really-quiet -noconsolecontrols -nojoystick -nolirc -nomouseinput -shuffle '+musicPathOff+' > /dev/null &')
		#give it priority or it won't play smoothly
		os.system("rm .pid")
		os.system("pidof mplayer > .pid")
		temp_pidfile = open('.pid', 'r')
		temp_pid = temp_pidfile.readline()
		temp_pid = temp_pid.rstrip("\n")
		temp_pidfile.close()
		os.system("renice -15 " + str(temp_pid))
		#look out for windows stealing our focus
		focusOutId=w.connect('focus_out_event', onFocusOutFunc)
		#exit on call
		os.system('python /usr/bin/detector.py > /dev/null &')

def oneFunc(target):
	global one
	global two
	global three
	global four
	one=1
	two=-1
	three=-1
	four=-1

def twoFunc(target):
	global one
	global two
	global three
	global four
	if one==1:
		two=1
	else:
		one=-1
		two=-1
		three=-1
		four=-1

def threeFunc(target):
	global one
	global two
	global three
	global four
	if two==1:
		three=1
	else:
		one=-1
		two=-1
		three=-1
		four=-1

def fourFunc(target):
	global one
	global two
	global three
	global four
	four*=-1
	if one==1 and two==1 and three==1 and four==1:
		temp_pidfile = open('.pid', 'r')
		temp_pid = temp_pidfile.readline()
		temp_pid = temp_pid.rstrip("\n")
		temp_pidfile.close()
		os.system("renice +0 " + str(temp_pid))
		unlock()
	else:
		one=-1
		two=-1
		three=-1
		four=-1

w = gtk.Window()

vBox = gtk.VBox()
hBoxExitLock = gtk.HBox()
hBoxVol = gtk.HBox()
hBoxOn = gtk.HBox()
hBoxOff = gtk.HBox()
lockUpBox = gtk.HBox()
lockDownBox = gtk.HBox()

exitButton = gtk.Button()
lockButton = gtk.Button()
bMute = gtk.Button()
handOnButton = gtk.Button()
headOnButton = gtk.Button()
handOffButton = gtk.Button()
headOffButton = gtk.Button()
oneButton = gtk.Button(label='1')
twoButton = gtk.Button(label='2')
threeButton = gtk.Button(label='3')
fourButton = gtk.Button(label='4')

volumeScale = gtk.HScale()
volumeScale.set_range(0, 127)
volumeScale.set_increments(1, 13)
volumeScale.set_digits(0)
volumeScale.set_value(float(defaultVolume))

exitImage = gtk.Image()
lockImage = gtk.Image()
handOnImage = gtk.Image()
headOnImage = gtk.Image()
handOffImage = gtk.Image()
headOffImage = gtk.Image()
unmuteImage = gtk.Image()
muteImage = gtk.Image()

atexit.register(cleanupFunc)
signal(SIGTERM, lambda signum, stack_frame: exit(0))

w.set_title('Bright Player')
w.set_icon_from_file('/usr/share/pixmaps/brightPlayer.png')

w.add(vBox)
hBoxExitLock.add(lockButton)
hBoxExitLock.add(exitButton)
hBoxOn.add(handOnButton)
hBoxOn.add(headOnButton)
hBoxOff.add(handOffButton)
hBoxOff.add(headOffButton)
hBoxVol.add(volumeScale)
hBoxVol.pack_end(bMute, False, False, 5)
lockUpBox.add(oneButton)
lockUpBox.add(fourButton)
lockDownBox.add(twoButton)
lockDownBox.add(threeButton)

vBox.add(hBoxExitLock)
vBox.add(hBoxVol)
vBox.add(hBoxOn)
vBox.add(hBoxOff)
vBox.add(lockUpBox)
vBox.add(lockDownBox)

exitImage.set_from_file('/usr/share/pixmaps/brightExit.png')
lockImage.set_from_file('/usr/share/pixmaps/brightLock.png')
handOnImage.set_from_file('/usr/share/pixmaps/brightHandOn.png')
headOnImage.set_from_file('/usr/share/pixmaps/brightHeadOn.png')
handOffImage.set_from_file('/usr/share/pixmaps/brightHandOff.png')
headOffImage.set_from_file('/usr/share/pixmaps/brightHeadOff.png')
unmuteImage.set_from_file('/usr/share/pixmaps/brightUnmute.png')
muteImage.set_from_file('/usr/share/pixmaps/brightMute.png')
lockButton.set_image(lockImage)
handOnButton.set_image(handOnImage)
headOnButton.set_image(headOnImage)
handOffButton.set_image(handOffImage)
headOffButton.set_image(headOffImage)
bMute.set_image(muteImage)
exitButton.set_image(exitImage)

w.connect('destroy_event', exitFunc)

exitButton.connect('clicked', exitFunc)
lockButton.connect('clicked', lock)
handOnButton.connect('clicked', playFunc, 'handOn')
headOnButton.connect('clicked', playFunc, 'headOn')
handOffButton.connect('clicked', playFunc, 'handOff')
headOffButton.connect('clicked', playFunc, 'headOff')
bMute.connect('clicked', mute)
volumeScale.connect("value-changed", volume)
oneButton.connect('clicked', oneFunc)
twoButton.connect('clicked', twoFunc)
threeButton.connect('clicked', threeFunc)
fourButton.connect('clicked', fourFunc)

w.show_all()

hBoxExitLock.hide()
hBoxVol.hide()
lockUpBox.hide()
lockDownBox.hide()

gtk.main()
